<template>
    <div>
        <p class="text-left">
            Enter your email to receive your password reset verification code
        </p>

        <ValidationObserver v-slot="{ handleSubmit }">
            <form @submit.prevent="handleSubmit(onForgotPassword)">
                <div class="mt-4">
                    <ValidationProvider
                        v-slot="{ errors }"
                        name="email"
                        rules="required|email"
                    >
                        <input
                            id="email"
                            v-model="email"
                            class="form-control"
                            name="email"
                            placeholder="Email"
                            type="email"
                        />
                        <div class="error-message">{{ errors[0] }}</div>
                    </ValidationProvider>
                </div>

                <div class="mt-4">
                    <button class="btn btn-fluid text-uppercase" type="submit">
                        Submit
                    </button>
                </div>
            </form>
        </ValidationObserver>

        <div class="mt-4">
            <a class="text-uppercase" href="#" @click="switchComponent('ResetPasswordForm')"> I have password reset
                verification code </a>
        </div>

        <div class="mt-4">
            <a href="#" @click="switchComponent('LoginForm')">
                <font-awesome-icon icon="chevron-left"/>
                Back to login </a>
        </div>
    </div>
</template>

<script>
import UserService from "@/services/UserService";

export default {
    name: "forgot-password-form-component",
    data() {
        return {
            email: ""
        };
    },
    methods: {
        /**
         * Show loading overlay.
         */
        showLoadingOverlay() {
            this.$JsLoadingOverlay.show({'spinnerIcon': 'ball-scale-multiple'});
        },

        /**
         * Hide loading overlay.
         */
        hideLoadingOverlay() {
            this.$JsLoadingOverlay.hide();
        },

        /**
         * Send forgot password email to user email.
         */
        onForgotPassword() {
            this.showLoadingOverlay();

            let vm = this;

            // Send reset password email to user.
            this.userService.sendResetPasswordEmail(this.email).then((result) => {
                this.hideLoadingOverlay();

                if (result.status !== 200) {
                    let message = 'Oops! Something went wrong.';

                    if (result.response !== undefined) {
                        message = result.response.data.message;
                    }

                    vm.$swal({
                        title: "Error!",
                        text: message,
                        icon: "error",
                        confirmButtonText: "OK"
                    });
                } else {
                    vm.$swal({
                        title: "Success",
                        text: "Please check your email for the reset password verification code.",
                        icon: "success",
                    }).then(function () {
                        vm.switchComponent('ResetPasswordForm');
                    });
                }
            });
        },

        /**
         * Switch component.
         *
         * @param componentName
         */
        switchComponent(componentName) {
            this.$emit("switchComponent", componentName);
        }
    },
    computed: {
        /**
         * Create UserService instance.
         *
         * @returns {UserService}
         */
        userService: function () {
            return new UserService(true);
        }
    },
};
</script>
